// Fichier Wav2MP3.cpp

#include <Windows.h>
#include <CommCtrl.h>
#include "resource.h"
#include <StdIO.h>
#include "AboutBox.h"
#include "MP3File.h"

HINSTANCE g_hInst;
HWND g_hDlg;
HANDLE hThread;
DWORD dwThID;
bool bSrc,bDst,bRunning,bStopWanted;
int iBRateIdx,iMaxBRateIdx;
char szBuffer[nBuffSize];

int iAllowedBR[]={32,40,48,56,64,80,96,112,128,160,192,224,256,320};

void DoEncodingEndStuff()
{
	// On r-active les contrles de la fentre
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_EXIT),TRUE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_ABOUT),TRUE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_BRWSE1),TRUE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_BRWSE2),TRUE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_START),TRUE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_CMB_BITRATE),TRUE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_CMB_MAXBITRATE),TRUE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_CHK_ENABLE_VBR),TRUE);
	// On positionne la ProgressBar au dbut
	//SendDlgItemMessage(g_hDlg,IDC_PRGBAR,PBM_SETPOS,0,0);
	// On dsactive le bouton arrter
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_STOP),FALSE);
	bRunning=false;
}
DWORD WINAPI EncodeWaveFile(LPVOID lParam)
{
	CMP3File *f_out;
	char szFName[MAX_PATH];
	FILE *fin;
	DWORD WSize; // Taille des donnes Wave  encoder
	WORD nChann; // Mono ou stro
	DWORD dwSmplRate; // Taux d'chantillonnage
	WORD nBits;
	int i;
	DWORD dwDone,dwPrcnt;
	// Ouverture du Wave et obtention des informations
	GetDlgItemText(g_hDlg,IDC_TXT_SRC,szFName,MAX_PATH);
	fin=fopen(szFName,"rb");
	if (fin==NULL)
	{
		MessageBox(g_hDlg,"Impossible d'ouvrir le fichier source.","Erreur",MB_ICONERROR);
		DoEncodingEndStuff();
		return 1;
	}
	fseek(fin,22,SEEK_SET);
	fread(&nChann,2,1,fin);
	fread(&dwSmplRate,4,1,fin);
	fseek(fin,34,SEEK_SET);
	fread(&nBits,2,1,fin);
	fseek(fin,40,SEEK_SET);
	fread(&WSize,4,1,fin);
	// Rcupration du format MP3 voulu
	DWORD dwMinBR=(DWORD)iAllowedBR[iBRateIdx];
	DWORD dwMaxBR=(DWORD)iAllowedBR[iMaxBRateIdx];
	bool bVBR=(SendDlgItemMessage(g_hDlg,IDC_CHK_ENABLE_VBR,BM_GETCHECK,0,0)==BST_CHECKED)?true:false;
	// Initialisation du fichier MP3
	GetDlgItemText(g_hDlg,IDC_TXT_DST,szFName,MAX_PATH);
	f_out=new CMP3File();
	f_out->SetFileName(szFName);
	f_out->SetSourceFormat(nChann,dwSmplRate,nBits);
	f_out->SetEncodingBitRate(dwMinBR);
	f_out->SetVBRMaxBitrate(dwMaxBR);
	f_out->EnableVBR(bVBR);
	if (f_out->Create()==0)
	{
		MessageBox(g_hDlg,"Impossible d'initialiser le fichier MP3","Erreur",MB_ICONERROR);
		DoEncodingEndStuff();
		delete f_out;
		return 1;
	}
	// On se place au dbut des donnes du wave
	fseek(fin,44,SEEK_SET);
	i=nBuffSize;
	dwDone=0;
	while((i==nBuffSize)&&(bStopWanted==false))
	{
		i=(int)fread(szBuffer,1,nBuffSize,fin);
		dwDone+=i;
		dwPrcnt=(int)(100.f*(((float)dwDone)/((float)WSize)));
		SendDlgItemMessage(g_hDlg,IDC_PRGBAR,PBM_SETPOS,(WPARAM)dwPrcnt,0);
		f_out->AddDatas(szBuffer,i);
	}
	fclose(fin);
	f_out->Close();
	delete f_out;
	DoEncodingEndStuff();
	return 0;
}

void OnAbout()
{
	CAboutBox *dlg;
	dlg=new CAboutBox(g_hDlg);
	dlg->ShowModal();
	delete dlg;
}

void BrowseForSrcFile()
{
	char szFName[MAX_PATH];
	GetDlgItemText(g_hDlg,IDC_TXT_SRC,szFName,MAX_PATH);
	OPENFILENAME ofn;
	ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=g_hDlg;
	ofn.hInstance=g_hInst;
	ofn.lpstrFilter="Fichiers Wave\0*.wav\0\0";
	ofn.lpstrCustomFilter=NULL;
	ofn.nFilterIndex=0;
	ofn.lpstrFile=szFName;
	ofn.nMaxFile=MAX_PATH;
	ofn.lpstrFileTitle=NULL;
	ofn.lpstrInitialDir=NULL;
	ofn.lpstrTitle="Slectionnez le fichier  compresser.";
	ofn.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;

	if (GetOpenFileName(&ofn)!=0)
	{
		SetDlgItemText(g_hDlg,IDC_TXT_SRC,szFName);
		bSrc=true;
	}
}

void BrowseForDstFile()
{
	char szFName[MAX_PATH];
	GetDlgItemText(g_hDlg,IDC_TXT_DST,szFName,MAX_PATH);
	OPENFILENAME ofn;
	ZeroMemory(&ofn,sizeof(OPENFILENAME));
	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=g_hDlg;
	ofn.hInstance=g_hInst;
	ofn.lpstrFilter="Fichiers MP3\0*.mp3\0\0";
	ofn.lpstrCustomFilter=NULL;
	ofn.nFilterIndex=0;
	ofn.lpstrFile=szFName;
	ofn.nMaxFile=MAX_PATH;
	ofn.lpstrFileTitle=NULL;
	ofn.lpstrInitialDir=NULL;
	ofn.lpstrTitle="Entrez le nom du fichier  crer.";
	ofn.Flags=OFN_EXPLORER|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;

	if (GetSaveFileName(&ofn)!=0)
	{
		SetDlgItemText(g_hDlg,IDC_TXT_DST,szFName);
		bDst=true;
	}
}

void OnInitDialog()
{
	// Initialiser les contrles
#ifdef _DEBUG
	SetDlgItemText(g_hDlg,IDC_TXT_SRC,"D:\\Dev\\VS.NET\\Wav2MP3\\Intro.wav");
	SetDlgItemText(g_hDlg,IDC_TXT_DST,"D:\\Dev\\VS.NET\\Wav2MP3\\Intro.mp3");
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_START),TRUE);
#endif
	int i;
	char szTxt[512];
	// ComboBox pour taux d'chantillonnage
	// ComboBox pour taux d'chantillonnage maxi
	for (i=0;i<14;i++)
	{
		sprintf(szTxt," %0d kbps",iAllowedBR[i]);
		SendDlgItemMessage(g_hDlg,IDC_CMB_BITRATE,CB_ADDSTRING,0,(LPARAM)szTxt);
		SendDlgItemMessage(g_hDlg,IDC_CMB_MAXBITRATE,CB_ADDSTRING,0,(LPARAM)szTxt);
	}
	iBRateIdx=10;
	SendDlgItemMessage(g_hDlg,IDC_CMB_BITRATE,CB_SETCURSEL,iBRateIdx,0);
	iMaxBRateIdx=12;
	SendDlgItemMessage(g_hDlg,IDC_CMB_MAXBITRATE,CB_SETCURSEL,iMaxBRateIdx,0);
	// CheckBox pour activer VBR
	SendDlgItemMessage(g_hDlg,IDC_CHK_ENABLE_VBR,BM_SETCHECK,BST_CHECKED,0);
}

void OnEnableVBRClicked()
{
	int iState=(int)SendDlgItemMessage(g_hDlg,IDC_CHK_ENABLE_VBR,BM_GETCHECK,0,0);
	BOOL bEnableCtrls=(iState==BST_CHECKED)?TRUE:FALSE;
	EnableWindow(GetDlgItem(g_hDlg,IDC_CMB_MAXBITRATE),bEnableCtrls);
	EnableWindow(GetDlgItem(g_hDlg,IDC_LBL_VBR2),bEnableCtrls);
	SetDlgItemText(g_hDlg,IDC_LBL_BITRATE,(bEnableCtrls)?"Taux minimum :":"Taux d'chantillonnage :");
}
void OnCmbBitrate(int nNotifCode)
{
	if (nNotifCode!=CBN_SELCHANGE) return;
	int iIdx,iVBR;
	// On doit vrifier, dans le cas de l'utilisation du taux variable,
	// que le taux mini n'est pas suprieur au taux maxi
	iIdx=(int)SendDlgItemMessage(g_hDlg,IDC_CMB_BITRATE,CB_GETCURSEL,0,0);
	iVBR=(int)SendDlgItemMessage(g_hDlg,IDC_CHK_ENABLE_VBR,BM_GETCHECK,0,0);
	if ((iIdx>=iMaxBRateIdx)&&(iVBR==BST_CHECKED))
	{
		MessageBox(g_hDlg,"Vous ne pouvez pas slectionner un taux suprieur au taux maxi !","Erreur",MB_ICONEXCLAMATION);
		SendDlgItemMessage(g_hDlg,IDC_CMB_BITRATE,CB_SETCURSEL,iBRateIdx,0);
	} else {
		iBRateIdx=iIdx;
	}
}
void OnCmbMaxBitrate(int nNotifCode)
{
	if (nNotifCode!=CBN_SELCHANGE) return;
	int iIdx;
	// On doit vrifier que le taux maxi n'est pas infrieur au taux mini
	iIdx=(int)SendDlgItemMessage(g_hDlg,IDC_CMB_MAXBITRATE,CB_GETCURSEL,0,0);
	if (iIdx<=iBRateIdx)
	{
		MessageBox(g_hDlg,"Vous ne pouvez pas slectionner un taux infrieur au taux mini !","Erreur",MB_ICONEXCLAMATION);
		SendDlgItemMessage(g_hDlg,IDC_CMB_MAXBITRATE,CB_SETCURSEL,iMaxBRateIdx,0);
	} else {
		iMaxBRateIdx=iIdx;
	}
}
void OnBtnExit()
{
	// On ne sort pas tant que a mouline
	if (bRunning==false) EndDialog(g_hDlg,0);
}
void OnBtnStart()
{
	// On dsactive les contrles de la fentre
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_EXIT),FALSE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_ABOUT),FALSE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_BRWSE1),FALSE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_BRWSE2),FALSE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_START),FALSE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_CMB_BITRATE),FALSE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_CMB_MAXBITRATE),FALSE);
	EnableWindow(GetDlgItem(g_hDlg,IDC_CHK_ENABLE_VBR),FALSE);
	// On positionne la ProgressBar au dbut
	SendDlgItemMessage(g_hDlg,IDC_PRGBAR,PBM_SETPOS,0,0);
	// On active le bouton arrter
	EnableWindow(GetDlgItem(g_hDlg,IDC_BTN_STOP),TRUE);
	bRunning=true;
	bStopWanted=false;
	hThread=CreateThread(NULL,0,EncodeWaveFile,NULL,0,&dwThID);
	if (hThread==NULL)
	{
		MessageBox(g_hDlg,"Impossible de crer le processus de travail !","Erreur",MB_ICONEXCLAMATION);
		DoEncodingEndStuff();
	}
}
void OnBtnStop()
{
	if (MessageBox(g_hDlg,"Confirmez-vous l'arrt du traitement ?","Arrt demand",MB_ICONQUESTION|MB_YESNO)==IDYES)
		bStopWanted=true;
}
BOOL CALLBACK MainDlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
			g_hDlg=hDlg;
			OnInitDialog();
			return TRUE;
		case WM_CLOSE:
		case WM_DESTROY:
			OnBtnExit();
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_BTN_START:
					OnBtnStart();
					break;
				case IDC_BTN_ABOUT:
					OnAbout();
					break;
				case IDC_BTN_EXIT:
					OnBtnExit();
					break;
				case IDC_BTN_BRWSE1:
					BrowseForSrcFile();
					EnableWindow(GetDlgItem(hDlg,IDC_BTN_START),((bSrc)&&(bDst)));
					break;
				case IDC_BTN_BRWSE2:
					BrowseForDstFile();
					EnableWindow(GetDlgItem(hDlg,IDC_BTN_START),((bSrc)&&(bDst)));
					break;
				case IDC_CHK_ENABLE_VBR:
					OnEnableVBRClicked();
					break;
				case IDC_CMB_BITRATE:
					OnCmbBitrate(HIWORD(wParam));
					break;
				case IDC_CMB_MAXBITRATE:
					OnCmbMaxBitrate(HIWORD(wParam));
					break;
				case IDC_BTN_STOP:
					OnBtnStop();
					break;
			}
			break;
	}
	return FALSE;
}

#ifdef _DEBUG
#include <crtdbg.h>
#include <stdio.h>

void DetectMemLeaks() 
{ 
	_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF); 
	_CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE); 
	_CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
}
#endif


int APIENTRY WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPTSTR lpCmdLine,int nCmdShow)
{
#ifdef _DEBUG
	DetectMemLeaks();
#endif
	g_hInst=hInst;
	bSrc=false;
	bDst=false;
	bRunning=false;
	InitCommonControls();
	DialogBox(hInst,MAKEINTRESOURCE(IDD_MAINFRAME),NULL,MainDlgProc);
	return 0;
}
